# include "../main/utilities.h"

# include "formula.h"
# include "formulaTest.h"



static std::string name = "formulaIdentifTest::";


FormulaIdentifTest::TestGetIDValue::TestGetIDValue() : Test() { }


FormulaIdentifTest::TestGetIDValue::~TestGetIDValue() { }


bool FormulaIdentifTest::TestGetIDValue::runTestAfterFork () {
	return testGetIDValue(); }


bool FormulaIdentifTest::TestGetIDValue::testGetIDValue() {
	std::string function = "testGetIDValue:";
	int testNumber = 0;
	bool failed = false;
	FormulaIdentif *ref = new FormulaIdentif(123876);

    testNumber++;
	if (ref->getIDValue() != 123876) {
		std::cout << name + function << testNumber << " wrong number\n";
		failed = 1; }

	ref->erase();
	ref = new FormulaIdentif(999999);

    testNumber++;
	if (ref->getIDValue() != 999999) {
		std::cout << name + function << testNumber << " wrong number\n";
		failed = 1; }

	ref->erase();
	ref = new FormulaIdentif(0);

    testNumber++;
	if (ref->getIDValue() != 0) {
		std::cout << name + function << testNumber << " wrong number\n";
		failed = 1; }

	ref->erase();
	return !failed; }


FormulaIdentifTest::TestEquals::TestEquals() : Test() { }


FormulaIdentifTest::TestEquals::~TestEquals() { }


bool FormulaIdentifTest::TestEquals::runTestAfterFork () {
	return testEquals(); }


bool FormulaIdentifTest::TestEquals::testEquals() {
	std::string function = "testEquals:";
	int testNumber = 0;
	bool failed = false;
	FormulaIdentif *ref1 = new FormulaIdentif(0);
	FormulaIdentif *ref2 = new FormulaIdentif(0);
	FormulaIdentif *ref3 = new FormulaIdentif(222);
	FormulaTrue *ref4 = new FormulaTrue();

	std::vector<Formula*> *ar = new std::vector<Formula*>();
	ar->push_back(ref1);
	ar->push_back(ref2);
	FormulaAnd *ref5 = new FormulaAnd(ar);

    testNumber++;
	if (! (ref1->equals(ref1))) {
		std::cout << name + function << testNumber << " ref1 SHOULD be equal "
			"to itself\n";
		failed = 1; }

    testNumber++;
	if (! (ref1->equals(ref2))) {
		std::cout << name + function << testNumber << " ref1 SHOULD be equal "
			"to ref2\n";
		failed = 1; }

    testNumber++;
	if (ref1->equals(ref3)) {
		std::cout << name + function << testNumber << " ref1 should NOT be "
			"equal to ref3\n";
		failed = 1; }

    testNumber++;
	if (ref1->equals(ref4)) {
		std::cout << name + function << testNumber << " ref1 should NOT be "
			"equal to ref4\n";
		failed = 1; }

    testNumber++;
	if (ref1->equals(ref5)) {
		std::cout << name + function << testNumber << " ref1 should NOT be "
			"equal to ref5\n";
		failed = 1; }

	delete ar;
	ref3->erase();
	ref4->erase();
	ref5->erase();
	return !failed; }


FormulaIdentifTest::TestGetValue::TestGetValue() : Test() { }


FormulaIdentifTest::TestGetValue::~TestGetValue() { }


bool FormulaIdentifTest::TestGetValue::runTestAfterFork () {
	return testGetValue(); }


bool FormulaIdentifTest::TestGetValue::testGetValue() {
	std::string function = "testGetValue:";
	int testNumber = 0;
	bool failed = false;
	FormulaIdentif *i = new FormulaIdentif(0);

	Assignment *v = new Assignment(1);
    testNumber++;
	if (i->getValue(v) != false) {
		std::cout << name + function << testNumber << " wrong value returned\n";
		failed = 1; }

	v->nextValueSet();
    testNumber++;
	if (i->getValue(v) != true) {
		std::cout << name + function << testNumber << " wrong value returned\n";
		failed = true; }

	i->erase();
	return !failed; }
