# include "../main/utilities.h"

# include "formula.h"
# include "formulaTest.h"



FormulaTest::FormulaTest() : TestSuite() {
	addTest(new FormulaTrueTest());
	addTest(new FormulaFalseTest());
	addTest(new FormulaIdentifTest());
	addTest(new FormulaBoxTest());
	addTest(new FormulaAndTest());
	addTest(new FormulaXorTest());
	addTest(new SequentTest()); }


FormulaTest::~FormulaTest() { }


FormulaTrueTest::FormulaTrueTest() : TestSuite() {
	addTest(new TestEquals());
	addTest(new TestGetValue()); }


FormulaTrueTest::~FormulaTrueTest() { }


FormulaFalseTest::FormulaFalseTest() : TestSuite() {
	addTest(new TestEquals());
	addTest(new TestGetValue()); }


FormulaFalseTest::~FormulaFalseTest() { }


FormulaIdentifTest::FormulaIdentifTest() : TestSuite() {
	addTest(new TestGetIDValue());
	addTest(new TestEquals());
	addTest(new TestGetValue()); }


FormulaIdentifTest::~FormulaIdentifTest() { }


FormulaBoxTest::FormulaBoxTest() : TestSuite() {
	addTest(new TestGetNumberOfElements());
	addTest(new TestGetElement());
	addTest(new TestEquals());
	addTest(new TestGetValue()); }


FormulaBoxTest::~FormulaBoxTest() { }


FormulaAndTest::FormulaAndTest() : TestSuite() {
	addTest(new TestGetNumberOfElements());
	addTest(new TestGetElement());
	addTest(new TestEquals());
	addTest(new TestGetValue()); }


FormulaAndTest::~FormulaAndTest() { }


FormulaXorTest::FormulaXorTest() : TestSuite() {
	addTest(new TestGetNumberOfElements());
	addTest(new TestGetElement());
	addTest(new TestEquals());
	addTest(new TestGetValue()); }


FormulaXorTest::~FormulaXorTest() { }


SequentTest::SequentTest() : TestSuite() {
	addTest(new TestEquals());
	addTest(new TestGetValue()); }


SequentTest::~SequentTest() { }

