# ifndef FORMULA_TEST_H
# define FORMULA_TEST_H

# include "../test/test.h"


/**
 *
 * This class tests all functionality of formulas.
 */
class FormulaTest : public TestSuite {
	public:
   		FormulaTest ();
   		~FormulaTest (); };



/**
 *
 * This class tests all functionality of the FormulaTrue class.
 */
class FormulaTrueTest : public TestSuite {
	public:
   		FormulaTrueTest ();
   		~FormulaTrueTest ();

	/*
	 * Tests the equal() function of the FormulaTrue Class.
	 */
	class TestEquals : public Test {
		public:
	        TestEquals();
	        ~TestEquals();
	        bool testEquals();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the getValue() function of the FormulaTrue Class.
	 */
	class TestGetValue : public Test {
		public:
	        TestGetValue();
	        ~TestGetValue();
	        bool testGetValue();
		protected:
	        bool runTestAfterFork (); }; };



/**
 *
 * This class tests all functionality of the FormulaFalse class.
 */
class FormulaFalseTest : public TestSuite {
	public:
   		FormulaFalseTest ();
   		~FormulaFalseTest ();

	/*
	 * Tests the equal() function of the FormulaFalse Class.
	 */
	class TestEquals : public Test {
		public:
	        TestEquals();
	        ~TestEquals();
	        bool testEquals();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the getValue() function of the FormulaFalse Class.
	 */
	class TestGetValue : public Test {
		public:
	        TestGetValue();
	        ~TestGetValue();
	        bool testGetValue();
		protected:
	        bool runTestAfterFork (); }; };



/**
 *
 * This class tests all functionality of the FormulaIdentif class.
 */
class FormulaIdentifTest : public TestSuite {
	public:
   		FormulaIdentifTest ();
   		~FormulaIdentifTest ();

	/*
	 * Tests the getIDValue() function of the FormulaIdentif Class.
	 */
	class TestGetIDValue : public Test {
		public:
	        TestGetIDValue();
	        ~TestGetIDValue();
	        bool testGetIDValue();
		protected:
    	    bool runTestAfterFork (); };

	/*
	 * Tests the equal() function of the FormulaIdentif Class.
	 */
	class TestEquals : public Test {
		public:
	        TestEquals();
	        ~TestEquals();
	        bool testEquals();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the getValue() function of the FormulaIdentif Class.
	 */
	class TestGetValue : public Test {
		public:
	        TestGetValue();
	        ~TestGetValue();
	        bool testGetValue();
		protected:
	        bool runTestAfterFork (); }; };



/**
 *
 * This class tests all functionality of the FormulaBox class.
 */
class FormulaBoxTest : public TestSuite {
	public:
   		FormulaBoxTest ();
   		~FormulaBoxTest ();

	/*
	 * Tests the getNumberOfElements() function of the FormulaBox Class.
	 */
	class TestGetNumberOfElements : public Test {
		public:
	        TestGetNumberOfElements();
	        ~TestGetNumberOfElements();
	        bool testGetNumberOfElements();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the getElement() function of the FormulaBox Class.
	 */
	class TestGetElement : public Test {
		public:
	        TestGetElement();
	        ~TestGetElement();
	        bool testGetElement();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the equal() function of the FormulaBox Class.
	 */
	class TestEquals : public Test {
		public:
	        TestEquals();
	        ~TestEquals();
	        bool testEquals();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the getValue() function of the FormulaBox Class.
	 */
	class TestGetValue : public Test {
		public:
	        TestGetValue();
	        ~TestGetValue();
	        bool testGetValue();
		protected:
	        bool runTestAfterFork (); }; };

    

/**
 *
 * This class tests all functionality of the FormulaAnd class.
 */
class FormulaAndTest : public TestSuite {
	public:
   		FormulaAndTest ();
   		~FormulaAndTest (); 

	/*
	 * Tests the getNumberOfElements() function of the FormulaAnd Class.
	 */
	class TestGetNumberOfElements : public Test {
		public:
	        TestGetNumberOfElements();
	        ~TestGetNumberOfElements();
	        bool testGetNumberOfElements();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the getElement() function of the FormulaAnd Class.
	 */
	class TestGetElement : public Test {
		public:
	        TestGetElement();
	        ~TestGetElement();
	        bool testGetElement();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the equal() function of the FormulaAnd Class.
	 */
	class TestEquals : public Test {
		public:
	        TestEquals();
	        ~TestEquals();
	        bool testEquals();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the getValue() function of the FormulaAnd Class.
	 */
	class TestGetValue : public Test {
		public:
	        TestGetValue();
	        ~TestGetValue();
	        bool testGetValue();
		protected:
	        bool runTestAfterFork (); }; };
    
    

/**
 *
 * This class tests all functionality of the FormulaXor class.
 */
class FormulaXorTest : public TestSuite {
	public:
   		FormulaXorTest ();
   		~FormulaXorTest ();

	/*
	 * Tests the getNumberOfElements() function of the FormulaXor Class.
	 */
	class TestGetNumberOfElements : public Test {
		public:
	        TestGetNumberOfElements();
	        ~TestGetNumberOfElements();
	        bool testGetNumberOfElements();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the getElement() function of the FormulaXor Class.
	 */
	class TestGetElement : public Test {
		public:
	        TestGetElement();
	        ~TestGetElement();
	        bool testGetElement();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the equals() function of the FormulaXor Class.
	 */
	class TestEquals : public Test {
		public:
	        TestEquals();
	        ~TestEquals();
	        bool testEquals();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the getValue() function of the FormulaXor Class.
	 */
	class TestGetValue : public Test {
		public:
	        TestGetValue();
	        ~TestGetValue();
	        bool testGetValue();
		protected:
	        bool runTestAfterFork (); }; };



/**
 *
 * This class tests all functionality of the Sequent class.
 */
class SequentTest : public TestSuite {
	public:
   		SequentTest ();
   		~SequentTest ();

	/*
	 * Tests the equals() function of the Sequent Class.
	 */
	class TestEquals : public Test {
		public:
	        TestEquals();
	        ~TestEquals();
	        bool testEquals();
		protected:
	        bool runTestAfterFork (); };

	/*
	 * Tests the getValue() function of the Sequent Class.
	 */
	class TestGetValue : public Test {
		public:
	        TestGetValue();
	        ~TestGetValue();
	        bool testGetValue();
		protected:
	        bool runTestAfterFork (); }; };



# endif // FORMULA_TEST_H
