# include "../main/utilities.h"

# include "../map/assignment.h"
# include "formula.h"
# include "formulaTest.h"



static std::string name = "sequentTest::";


SequentTest::TestEquals::TestEquals() : Test() { }


SequentTest::TestEquals::~TestEquals() { }


bool SequentTest::TestEquals::runTestAfterFork () {
	return testEquals(); }


bool SequentTest::TestEquals::testEquals() {
	std::string function = "testEquals:";
	int testNumber = 0;
	bool failed = false;
	FormulaFalse *f1 = new FormulaFalse();
	FormulaFalse *f2 = new FormulaFalse();

	std::vector<Formula*> *v = new std::vector<Formula*>();
	v->push_back(f1);
	v->push_back(f1);
	Sequent *ref1 = new Sequent(v, NULL);

	v->clear();
	v->push_back(f2);
	v->push_back(f2);
	Sequent *ref2 = new Sequent(v, NULL);

	FormulaIdentif *i = new FormulaIdentif(0);

	v->clear();
	v->push_back(i);
	v->push_back(i);
	Sequent *ref3 = new Sequent(v, NULL);

    testNumber++;
	if (! (ref1->equals(ref1))) {
		std::cout << name + function << testNumber << " ref1 SHOULD be equal "
			"to itself\n";
		failed = true; }

    testNumber++;
	if (! (ref1->equals(ref2))) {
		std::cout << name + function << testNumber << " ref1 SHOULD be equal "
			"to ref2\n";
		failed = true; }

    testNumber++;
	if (ref1->equals(ref3)) {
		std::cout << name + function << testNumber << " ref1 should NOT be "
			"equal to ref3\n";
		failed = true; }

	delete ref1;
	ref1 = new Sequent(NULL, f1);

	delete ref2;
	ref2 = new Sequent(NULL, f2);

	delete ref3;
	ref3 = new Sequent(NULL, i);

    testNumber++;
	if (! (ref1->equals(ref1))) {
		std::cout << name + function << testNumber << " ref1 SHOULD be equal "
			"to itself\n";
		failed = true; }

    testNumber++;
	if (! (ref1->equals(ref2))) {
		std::cout << name + function << testNumber << " ref1 SHOULD be equal "
			"to ref2\n";
		failed = true; }

    testNumber++;
	if (ref1->equals(ref3)) {
		std::cout << name + function << testNumber << " ref1 should NOT be "
			"equal to ref3\n";
		failed = true; }

    testNumber++;
	if (ref1->equals(f1)) {
		std::cout << name + function << testNumber << " ref1 should NOT be "
			"equal to a\n";
		failed = true; }

	delete v;
	delete f1;
	delete f2;
	delete ref1;
	delete ref2;
	delete i;
	delete ref3;
	return !failed; }


SequentTest::TestGetValue::TestGetValue() : Test() { }


SequentTest::TestGetValue::~TestGetValue() { }


bool SequentTest::TestGetValue::runTestAfterFork () {
	return testGetValue(); }


bool SequentTest::TestGetValue::testGetValue() {
	std::string function = "testGetNumberOfElements:";
	int testNumber = 0;
	bool failed = false;
	FormulaTrue *t = new FormulaTrue();
	FormulaIdentif *i1 = new FormulaIdentif(0);
	FormulaIdentif *i2 = new FormulaIdentif(1);
	FormulaIdentif *i2b = new FormulaIdentif(1);
	FormulaIdentif *i3 = new FormulaIdentif(2);
	std::vector<Formula*> *elements = new std::vector<Formula*>();
	elements->push_back(t);
	elements->push_back(i1);
	elements->push_back(i2);
	std::vector<Formula*> *fxElements = new std::vector<Formula*>();
	fxElements->push_back(i2b);
	fxElements->push_back(i3);
	FormulaXor *fx = new FormulaXor(fxElements);
	Sequent *ref = new Sequent(elements, fx);

	Assignment *v = new Assignment(3);
    testNumber++;
	if (ref->getValue(v) != true) {
		std::cout << name + function << testNumber << " wrong value "
			"returned\n";
		failed = true; }

	v->nextValueSet();
    testNumber++;
	if (ref->getValue(v) != true) {
		std::cout << name + function << testNumber << " wrong value "
			"returned\n";
		failed = true; }

	v->nextValueSet();
    testNumber++;
	if (ref->getValue(v) != true) {
		std::cout << name + function << testNumber << " wrong value "
			"returned\n";
		failed = true; }

	v->nextValueSet();
    testNumber++;
	if (ref->getValue(v) != true) {
		std::cout << name + function << testNumber << " wrong value "
			"returned\n";
		failed = true; }

	v->nextValueSet();
    testNumber++;
	if (ref->getValue(v) != true) {
		std::cout << name + function << testNumber << " wrong value "
			"returned\n";
		failed = true; }

	v->nextValueSet();
    testNumber++;
	if (ref->getValue(v) != true) {
		std::cout << name + function << testNumber << " wrong value "
			"returned\n";
		failed = true; }

	v->nextValueSet();
    testNumber++;
	if (ref->getValue(v) != true) {
		std::cout << name + function << testNumber << " wrong value "
			"returned\n";
		failed = true; }

	v->nextValueSet();
    testNumber++;
	if (ref->getValue(v) != false) {
		std::cout << name + function << testNumber << " wrong value "
			"returned\n";
		failed = true; }

	delete elements;
	delete fxElements;
	ref->clear();
	delete ref;
	return !failed; }
