# ifndef MAIN_H
# define MAIN_H

# include <string>

# include "../map/IDmap.h"
# include "../map/assignment.h"
# include "../formula/formula.h"
# include "../parser/parser.h"


/*
 * @param parameter: the parameter to be analysed
 * reads an inline parameter and executes it.
 */
void readParameter (char *parameter);

/*
 * run the automated tests and prints the results.
 */
void runTests();

/*
 * runs a step-by-step execution (not fully implemented yet!).
 */
void runStepExec();

/*
 * @param parameter: the file's name/path
 * process a file and prints the results.
 */
void processFile(char *parameter);

/*
 * @param command: the string containing the formula to be executed
 * process a formula and displays the results.
 */
void processCommand (std::string* command);

/*
 * @param in: an imput stream to the file.
 * @param lineAhead: that's the look-ahead for reading the file. It contains a
 * whole line.
 * returns the next command in a file.
 */
std::string* getNextCommand(std::ifstream &in, std::string &lineAhead);


# endif // MAIN_H
