# ifndef MAP_H
# define MAP_H

# include <vector>


/**
 *
 * This class maps identifiers to IDs
 */
class Map {
	public:
		Map();
		~Map();
		
		/*
		 * Returns the current number of IDs registered in this map.
		 */
		int numberOfElements();
		/*
		 * @param element: the identifier queried.
		 * Returns true if this map contains @element. Returns false otherwise.
		 *
		 * Note: @element isn't added to the map.
		 */
		bool contains (std::string *element);
		/*
		 * @param element: the identifier queried.
		 * Returns the ID of the requested @element.
		 *
		 * Note: if the identifier isn't present in this map, It is added.
		 */
		int getValue (std::string *element);
		/*
		 * @param index: the ID required.
		 * Returns the identifier mapped by the requested ID.
		 */
		std::string* getElement (int index);
		
	private:
		std::vector<std::string *> *elementList;
		/*
		 * @param element: the identifier queried.
		 * Returns the ID of the requested @element, if possible. Returns -1
		 * otherwise.
		 *
		 * Note: @element isn't added to the map.
		 */
		int search (std::string *element);
		/*
		 * @param element: the identifier to be added.
		 * Adds @element to this map.
		 */
		void add (std::string *element); };



# endif //MAP_H
