# ifndef VALORACAO_H
# define VALORACAO_H

# include <vector>


/**
 *
 * This class maps a boolean value to each ID
 */
class Assignment {
	public:
		/*
		 * @param elements: the number of ID to be assigned.
		 */
		Assignment(int elements);
		~Assignment();

		/*
		 * Returns the number of ID that are being assigned.
		 */
		int numberOfElements();
		/*
		 * @param value: the value to be assigned.
		 * @param ID: the ID to receive the required value
		 * Assigns @value to the ID @ID.
		 */
		void setValue (bool value, int ID);
		/*
		 * @param ID: the ID queried.
		 * Returns the value assigned to the ID @ID.
		 */
		bool getValue (int ID);
		/*
		 * Sets all IDs to a new assignment.
		 *
		 * Note: when created, this instance assigns false to all IDs. If this
		 *      function is used until all IDs are assigned to true, then it's
		 *      garanteed that all possible combinations have been assigned.
		 */
		void nextValueSet();
		/*
		 * Returns true if all IDs are assigned to true. Returns false otherwise
		 */
		bool isAllValuesTrue();

	private:
		std::vector<bool> *elementList;
		int elements; };



# endif //VALORACAO_H
