# include "../main/utilities.h"

# include "../formula/formula.h"
# include "stack.h"
# include "stackTest.h"


static std::string name = "stackTest::";


StackTest::StackTest() : TestSuite() {
	addTest(new TestPush());
	addTest(new TestPop()); }


StackTest::~StackTest() { }


StackTest::TestPush::TestPush() : Test() { }


StackTest::TestPush::~TestPush() { }


bool StackTest::TestPush::runTestAfterFork () {
	return testPush(); }


bool StackTest::TestPush::testPush() {
	std::string function = "testPush:";
	int testNumber = 0;
	bool failed = false;
	Stack *s = new Stack();

    testNumber++;
	if (!failed && s->getSize() != 0) {
		std::cout << name + function << testNumber << " stack isn't empty"
		        " at start\n";
		failed = true; }

	s->push(new FormulaTrue());
    testNumber++;
	if (!failed && s->getSize() != 1) {
		std::cout << name + function << testNumber << " new element missing\n";
		failed = true; }

	s->push(new FormulaFalse());
    testNumber++;
	if (!failed && s->getSize() != 2) {
		std::cout << name + function << testNumber << " second element"
			" missing\n";
		failed = true; }

	while (s->getSize() > 0) delete s->pop();
	delete s;
	return !failed; }


StackTest::TestPop::TestPop() : Test() { }


StackTest::TestPop::~TestPop() { }


bool StackTest::TestPop::runTestAfterFork () {
	return testPop(); }


bool StackTest::TestPop::testPop() {
	std::string function = "testPop:";
	int testNumber = 0;
	bool failed = false;
	Stack *s = new Stack();

	s->push(new FormulaTrue());
	Formula *f = s->pop();
    testNumber++;
	if (!failed && dynamic_cast<FormulaTrue *>(f) == NULL) {
		std::cout << name + function << testNumber << " wrong element"
			" returned\n";
		failed = true; }

	delete f;
	s->push(new FormulaFalse());
	f = s->pop();
	testNumber++;
	if (!failed && dynamic_cast<FormulaFalse *>(f) == NULL) {
		std::cout << name + function << testNumber << " wrong element"
			" returned\n";
		failed = true; }

	f->erase();
	delete s;
	return !failed; }
