# include <cstdlib>
# include "../main/utilities.h"

# include "test.h"



Test::Test () {
	passed = -1;
	failed = -1; }



Test::~Test() { }



void Test::runTest () {
	passed = 0;
	failed = 0;

/*    pid_t pid;
	pid = fork();

	if (pid == -1) {
		passed = -1;
		failed = -1;
		return; }

	if (pid != 0) {
		wait(&pid);
		return; }

	if (pid == 0) {
*/
		if (runTestAfterFork()) passed++;
		else failed++; }

//		exit(0); }}



int Test::getPassedTests () {
	return passed; }



int Test::getFailedTests () {
	return failed; }



void Test::print () {
	int lastPassed = getPassedTests();
	int lastFailed = getFailedTests();
	
	if (lastPassed == -1 || lastFailed == -1) {
		std::cout << "Missing test results. Rerun the test and try again." <<
		    std::endl << std::endl;
		return; }

	std::cout << lastPassed << "/" << lastPassed + lastFailed
			<< " tests passed." << std::endl;
	if (lastFailed != 0) std::cout << lastFailed << "/" << lastPassed +
			lastFailed << " tests failed." << std::endl;
	else std::cout << "All tests passed." << std::endl;
	std::cout << std::endl; }


bool Test::runTestAfterFork () {
	return true; }



TestSuite::TestSuite () {
	tests = new std::vector<Test*>(); }



TestSuite::~TestSuite () {
	delete tests; }



void TestSuite::runTest () {
	for (unsigned i = 0; i < tests->size(); i++) {
		tests->at(i)->runTest(); }}



int TestSuite::getPassedTests () {
	int sum = 0, passed;
	for (unsigned i = 0; i < tests->size(); i++) {
		passed = tests->at(i)->getPassedTests();
		if (passed == -1) return -1;
		sum += passed; }
	return sum; }



int TestSuite::getFailedTests () {
	int sum = 0, failed;
	for (unsigned i = 0; i < tests->size(); i++) {
		failed = tests->at(i)->getFailedTests();
		if (failed == -1) return -1;
		sum += failed; }
	return sum; }



void TestSuite::addTest (Test *newTest) {
	tests->push_back(newTest); }

