# ifndef TEST_H
# define TEST_H

# include <vector>


/*
 *
 * This class defines a test.
 *      getPassedTests() and getFailedTests() returns, respectively, how many
 *      tests passed and failed during the last runTest() call in the instance.
 */
class Test {
	public:
		Test ();
		virtual ~Test();

		virtual void runTest ();
		virtual int getPassedTests ();
		virtual int getFailedTests ();
		void print ();

	protected:
		virtual bool runTestAfterFork ();

	private:
		int passed, failed; };



/*
 * This class defines a group of tests. It can be used like a test after all
 * tests have been added.
 */
class TestSuite: public Test {
	public:
		TestSuite ();
		~TestSuite ();

		void runTest ();
		int getPassedTests ();
		int getFailedTests ();
		void addTest (Test *newTest);

	private:
        std::vector<Test*> *tests; };


# endif // TEST_H
